/**
 * <copyright>
 * </copyright>
 *
 * $Id: ComponentImpl.java 8768 2011-11-23 15:48:49Z laslovd $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.impl.ModelElementImpl;
import org.openxma.dsl.dom.model.ConditionsBlock;
import org.openxma.dsl.dom.model.Dependant;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.Component;
import org.openxma.dsl.pom.model.CustomizeAttributeList;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.Definitions;
import org.openxma.dsl.pom.model.EventMappingList;
import org.openxma.dsl.pom.model.Invokeable;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.ReferencedXMAGuiElement;
import org.openxma.dsl.pom.model.StyleProperty;

import org.openxma.dsl.pom.model.XmadslPage;
import at.spardat.xma.guidesign.XMAComponent;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getXmaComponent <em>Xma Component</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getStyleProperty <em>Style Property</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getDefaultPage <em>Default Page</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getDependencies <em>Dependencies</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getComponentProperties <em>Component Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getDataobjects <em>Dataobjects</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getCustomizedAttributeList <em>Customized Attribute List</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getCommands <em>Commands</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getConditionsBlock <em>Conditions Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getPages <em>Pages</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ComponentImpl#getDefinitions <em>Definitions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComponentImpl extends ModelElementImpl implements Component {
	/**
     * The cached value of the '{@link #getXmaComponent() <em>Xma Component</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getXmaComponent()
     * @generated
     * @ordered
     */
	protected XMAComponent xmaComponent;

	/**
     * The cached value of the '{@link #getStyleProperty() <em>Style Property</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getStyleProperty()
     * @generated
     * @ordered
     */
	protected StyleProperty styleProperty;

	/**
     * The cached value of the '{@link #getDefaultPage() <em>Default Page</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDefaultPage()
     * @generated
     * @ordered
     */
    protected XmadslPage defaultPage;

    /**
     * The cached value of the '{@link #getDependencies() <em>Dependencies</em>}' reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getDependencies()
     * @generated
     * @ordered
     */
	protected EList<Dependant> dependencies;

	/**
     * The cached value of the '{@link #getComponentProperties() <em>Component Properties</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getComponentProperties()
     * @generated
     * @ordered
     */
	protected EList<ObjectProperty> componentProperties;

	/**
     * The cached value of the '{@link #getDataobjects() <em>Dataobjects</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getDataobjects()
     * @generated
     * @ordered
     */
	protected EList<DataObjectVariable> dataobjects;

	/**
     * The cached value of the '{@link #getCustomizedAttributeList() <em>Customized Attribute List</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getCustomizedAttributeList()
     * @generated
     * @ordered
     */
	protected CustomizeAttributeList customizedAttributeList;

	/**
     * The cached value of the '{@link #getCommands() <em>Commands</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getCommands()
     * @generated
     * @ordered
     */
	protected EList<Command> commands;

	/**
     * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getEvents()
     * @generated
     * @ordered
     */
	protected EventMappingList events;

	/**
     * The cached value of the '{@link #getConditionsBlock() <em>Conditions Block</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getConditionsBlock()
     * @generated
     * @ordered
     */
	protected ConditionsBlock conditionsBlock;

	/**
     * The cached value of the '{@link #getPages() <em>Pages</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getPages()
     * @generated
     * @ordered
     */
	protected EList<Page> pages;

	/**
     * The cached value of the '{@link #getDefinitions() <em>Definitions</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getDefinitions()
     * @generated
     * @ordered
     */
	protected Definitions definitions;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected ComponentImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return PomPackage.Literals.COMPONENT;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public XMAComponent getXmaComponent() {
        if (xmaComponent != null && xmaComponent.eIsProxy()) {
            InternalEObject oldXmaComponent = (InternalEObject)xmaComponent;
            xmaComponent = (XMAComponent)eResolveProxy(oldXmaComponent);
            if (xmaComponent != oldXmaComponent) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.COMPONENT__XMA_COMPONENT, oldXmaComponent, xmaComponent));
            }
        }
        return xmaComponent;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public XMAComponent basicGetXmaComponent() {
        return xmaComponent;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setXmaComponent(XMAComponent newXmaComponent) {
        XMAComponent oldXmaComponent = xmaComponent;
        xmaComponent = newXmaComponent;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__XMA_COMPONENT, oldXmaComponent, xmaComponent));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public StyleProperty getStyleProperty() {
        return styleProperty;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetStyleProperty(StyleProperty newStyleProperty, NotificationChain msgs) {
        StyleProperty oldStyleProperty = styleProperty;
        styleProperty = newStyleProperty;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__STYLE_PROPERTY, oldStyleProperty, newStyleProperty);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setStyleProperty(StyleProperty newStyleProperty) {
        if (newStyleProperty != styleProperty) {
            NotificationChain msgs = null;
            if (styleProperty != null)
                msgs = ((InternalEObject)styleProperty).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__STYLE_PROPERTY, null, msgs);
            if (newStyleProperty != null)
                msgs = ((InternalEObject)newStyleProperty).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__STYLE_PROPERTY, null, msgs);
            msgs = basicSetStyleProperty(newStyleProperty, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__STYLE_PROPERTY, newStyleProperty, newStyleProperty));
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public XmadslPage getDefaultPage() {
        if (defaultPage != null && defaultPage.eIsProxy()) {
            InternalEObject oldDefaultPage = (InternalEObject)defaultPage;
            defaultPage = (XmadslPage)eResolveProxy(oldDefaultPage);
            if (defaultPage != oldDefaultPage) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.COMPONENT__DEFAULT_PAGE, oldDefaultPage, defaultPage));
            }
        }
        return defaultPage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public XmadslPage basicGetDefaultPage() {
        return defaultPage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDefaultPage(XmadslPage newDefaultPage) {
        XmadslPage oldDefaultPage = defaultPage;
        defaultPage = newDefaultPage;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__DEFAULT_PAGE, oldDefaultPage, defaultPage));
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<Dependant> getDependencies() {
        if (dependencies == null) {
            dependencies = new EObjectResolvingEList<Dependant>(Dependant.class, this, PomPackage.COMPONENT__DEPENDENCIES);
        }
        return dependencies;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<ObjectProperty> getComponentProperties() {
        if (componentProperties == null) {
            componentProperties = new EObjectContainmentEList<ObjectProperty>(ObjectProperty.class, this, PomPackage.COMPONENT__COMPONENT_PROPERTIES);
        }
        return componentProperties;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<DataObjectVariable> getDataobjects() {
        if (dataobjects == null) {
            dataobjects = new EObjectContainmentEList<DataObjectVariable>(DataObjectVariable.class, this, PomPackage.COMPONENT__DATAOBJECTS);
        }
        return dataobjects;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public CustomizeAttributeList getCustomizedAttributeList() {
        return customizedAttributeList;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetCustomizedAttributeList(CustomizeAttributeList newCustomizedAttributeList, NotificationChain msgs) {
        CustomizeAttributeList oldCustomizedAttributeList = customizedAttributeList;
        customizedAttributeList = newCustomizedAttributeList;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST, oldCustomizedAttributeList, newCustomizedAttributeList);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setCustomizedAttributeList(CustomizeAttributeList newCustomizedAttributeList) {
        if (newCustomizedAttributeList != customizedAttributeList) {
            NotificationChain msgs = null;
            if (customizedAttributeList != null)
                msgs = ((InternalEObject)customizedAttributeList).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST, null, msgs);
            if (newCustomizedAttributeList != null)
                msgs = ((InternalEObject)newCustomizedAttributeList).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST, null, msgs);
            msgs = basicSetCustomizedAttributeList(newCustomizedAttributeList, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST, newCustomizedAttributeList, newCustomizedAttributeList));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<Command> getCommands() {
        if (commands == null) {
            commands = new EObjectContainmentEList<Command>(Command.class, this, PomPackage.COMPONENT__COMMANDS);
        }
        return commands;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EventMappingList getEvents() {
        return events;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetEvents(EventMappingList newEvents, NotificationChain msgs) {
        EventMappingList oldEvents = events;
        events = newEvents;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__EVENTS, oldEvents, newEvents);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setEvents(EventMappingList newEvents) {
        if (newEvents != events) {
            NotificationChain msgs = null;
            if (events != null)
                msgs = ((InternalEObject)events).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__EVENTS, null, msgs);
            if (newEvents != null)
                msgs = ((InternalEObject)newEvents).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__EVENTS, null, msgs);
            msgs = basicSetEvents(newEvents, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__EVENTS, newEvents, newEvents));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ConditionsBlock getConditionsBlock() {
        return conditionsBlock;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetConditionsBlock(ConditionsBlock newConditionsBlock, NotificationChain msgs) {
        ConditionsBlock oldConditionsBlock = conditionsBlock;
        conditionsBlock = newConditionsBlock;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__CONDITIONS_BLOCK, oldConditionsBlock, newConditionsBlock);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setConditionsBlock(ConditionsBlock newConditionsBlock) {
        if (newConditionsBlock != conditionsBlock) {
            NotificationChain msgs = null;
            if (conditionsBlock != null)
                msgs = ((InternalEObject)conditionsBlock).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__CONDITIONS_BLOCK, null, msgs);
            if (newConditionsBlock != null)
                msgs = ((InternalEObject)newConditionsBlock).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__CONDITIONS_BLOCK, null, msgs);
            msgs = basicSetConditionsBlock(newConditionsBlock, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__CONDITIONS_BLOCK, newConditionsBlock, newConditionsBlock));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<Page> getPages() {
        if (pages == null) {
            pages = new EObjectContainmentEList<Page>(Page.class, this, PomPackage.COMPONENT__PAGES);
        }
        return pages;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public Definitions getDefinitions() {
        return definitions;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetDefinitions(Definitions newDefinitions, NotificationChain msgs) {
        Definitions oldDefinitions = definitions;
        definitions = newDefinitions;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__DEFINITIONS, oldDefinitions, newDefinitions);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setDefinitions(Definitions newDefinitions) {
        if (newDefinitions != definitions) {
            NotificationChain msgs = null;
            if (definitions != null)
                msgs = ((InternalEObject)definitions).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__DEFINITIONS, null, msgs);
            if (newDefinitions != null)
                msgs = ((InternalEObject)newDefinitions).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.COMPONENT__DEFINITIONS, null, msgs);
            msgs = basicSetDefinitions(newDefinitions, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.COMPONENT__DEFINITIONS, newDefinitions, newDefinitions));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case PomPackage.COMPONENT__STYLE_PROPERTY:
                return basicSetStyleProperty(null, msgs);
            case PomPackage.COMPONENT__COMPONENT_PROPERTIES:
                return ((InternalEList<?>)getComponentProperties()).basicRemove(otherEnd, msgs);
            case PomPackage.COMPONENT__DATAOBJECTS:
                return ((InternalEList<?>)getDataobjects()).basicRemove(otherEnd, msgs);
            case PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST:
                return basicSetCustomizedAttributeList(null, msgs);
            case PomPackage.COMPONENT__COMMANDS:
                return ((InternalEList<?>)getCommands()).basicRemove(otherEnd, msgs);
            case PomPackage.COMPONENT__EVENTS:
                return basicSetEvents(null, msgs);
            case PomPackage.COMPONENT__CONDITIONS_BLOCK:
                return basicSetConditionsBlock(null, msgs);
            case PomPackage.COMPONENT__PAGES:
                return ((InternalEList<?>)getPages()).basicRemove(otherEnd, msgs);
            case PomPackage.COMPONENT__DEFINITIONS:
                return basicSetDefinitions(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case PomPackage.COMPONENT__XMA_COMPONENT:
                if (resolve) return getXmaComponent();
                return basicGetXmaComponent();
            case PomPackage.COMPONENT__STYLE_PROPERTY:
                return getStyleProperty();
            case PomPackage.COMPONENT__DEFAULT_PAGE:
                if (resolve) return getDefaultPage();
                return basicGetDefaultPage();
            case PomPackage.COMPONENT__DEPENDENCIES:
                return getDependencies();
            case PomPackage.COMPONENT__COMPONENT_PROPERTIES:
                return getComponentProperties();
            case PomPackage.COMPONENT__DATAOBJECTS:
                return getDataobjects();
            case PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST:
                return getCustomizedAttributeList();
            case PomPackage.COMPONENT__COMMANDS:
                return getCommands();
            case PomPackage.COMPONENT__EVENTS:
                return getEvents();
            case PomPackage.COMPONENT__CONDITIONS_BLOCK:
                return getConditionsBlock();
            case PomPackage.COMPONENT__PAGES:
                return getPages();
            case PomPackage.COMPONENT__DEFINITIONS:
                return getDefinitions();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case PomPackage.COMPONENT__XMA_COMPONENT:
                setXmaComponent((XMAComponent)newValue);
                return;
            case PomPackage.COMPONENT__STYLE_PROPERTY:
                setStyleProperty((StyleProperty)newValue);
                return;
            case PomPackage.COMPONENT__DEFAULT_PAGE:
                setDefaultPage((XmadslPage)newValue);
                return;
            case PomPackage.COMPONENT__DEPENDENCIES:
                getDependencies().clear();
                getDependencies().addAll((Collection<? extends Dependant>)newValue);
                return;
            case PomPackage.COMPONENT__COMPONENT_PROPERTIES:
                getComponentProperties().clear();
                getComponentProperties().addAll((Collection<? extends ObjectProperty>)newValue);
                return;
            case PomPackage.COMPONENT__DATAOBJECTS:
                getDataobjects().clear();
                getDataobjects().addAll((Collection<? extends DataObjectVariable>)newValue);
                return;
            case PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST:
                setCustomizedAttributeList((CustomizeAttributeList)newValue);
                return;
            case PomPackage.COMPONENT__COMMANDS:
                getCommands().clear();
                getCommands().addAll((Collection<? extends Command>)newValue);
                return;
            case PomPackage.COMPONENT__EVENTS:
                setEvents((EventMappingList)newValue);
                return;
            case PomPackage.COMPONENT__CONDITIONS_BLOCK:
                setConditionsBlock((ConditionsBlock)newValue);
                return;
            case PomPackage.COMPONENT__PAGES:
                getPages().clear();
                getPages().addAll((Collection<? extends Page>)newValue);
                return;
            case PomPackage.COMPONENT__DEFINITIONS:
                setDefinitions((Definitions)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case PomPackage.COMPONENT__XMA_COMPONENT:
                setXmaComponent((XMAComponent)null);
                return;
            case PomPackage.COMPONENT__STYLE_PROPERTY:
                setStyleProperty((StyleProperty)null);
                return;
            case PomPackage.COMPONENT__DEFAULT_PAGE:
                setDefaultPage((XmadslPage)null);
                return;
            case PomPackage.COMPONENT__DEPENDENCIES:
                getDependencies().clear();
                return;
            case PomPackage.COMPONENT__COMPONENT_PROPERTIES:
                getComponentProperties().clear();
                return;
            case PomPackage.COMPONENT__DATAOBJECTS:
                getDataobjects().clear();
                return;
            case PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST:
                setCustomizedAttributeList((CustomizeAttributeList)null);
                return;
            case PomPackage.COMPONENT__COMMANDS:
                getCommands().clear();
                return;
            case PomPackage.COMPONENT__EVENTS:
                setEvents((EventMappingList)null);
                return;
            case PomPackage.COMPONENT__CONDITIONS_BLOCK:
                setConditionsBlock((ConditionsBlock)null);
                return;
            case PomPackage.COMPONENT__PAGES:
                getPages().clear();
                return;
            case PomPackage.COMPONENT__DEFINITIONS:
                setDefinitions((Definitions)null);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case PomPackage.COMPONENT__XMA_COMPONENT:
                return xmaComponent != null;
            case PomPackage.COMPONENT__STYLE_PROPERTY:
                return styleProperty != null;
            case PomPackage.COMPONENT__DEFAULT_PAGE:
                return defaultPage != null;
            case PomPackage.COMPONENT__DEPENDENCIES:
                return dependencies != null && !dependencies.isEmpty();
            case PomPackage.COMPONENT__COMPONENT_PROPERTIES:
                return componentProperties != null && !componentProperties.isEmpty();
            case PomPackage.COMPONENT__DATAOBJECTS:
                return dataobjects != null && !dataobjects.isEmpty();
            case PomPackage.COMPONENT__CUSTOMIZED_ATTRIBUTE_LIST:
                return customizedAttributeList != null;
            case PomPackage.COMPONENT__COMMANDS:
                return commands != null && !commands.isEmpty();
            case PomPackage.COMPONENT__EVENTS:
                return events != null;
            case PomPackage.COMPONENT__CONDITIONS_BLOCK:
                return conditionsBlock != null;
            case PomPackage.COMPONENT__PAGES:
                return pages != null && !pages.isEmpty();
            case PomPackage.COMPONENT__DEFINITIONS:
                return definitions != null;
        }
        return super.eIsSet(featureID);
    }

} //ComponentImpl
